'-------------------------------------------------------------------------------
' In The Name Of GOD

'Topic  : Line Follower Robat
'Author : Morteza Rahimi Kordmahalle (MRK)
'Microcontroller : ATTiny2313

'Compiler : BASCOM 1.11.9.8
'Creation Date : Oct 15, 2011 (1390.07.23)
'Copyright : (C) 2011 By www.mrkelectronic.blogfa.com
'License : This Is A Free Firmware , Ver 1.00

'-------------------------------------------------------------------------------

$regfile = "attiny2313.dat"
$crystal = 8000000

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Configurations ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Config Timer1 = Pwm , Pwm = 10 , Compare A Pwm = Clear Down , Compare B Pwm = Clear Down , Prescale = 64

Config Portd = Input
Config Portb = Output

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Variable ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Dim A As Word , B As Word

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ initionaliz ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

'motore rast
Pwm1a = 1023
Portb.0 = 1
Portb.1 = 0

'motore chap
Pwm1b = 1023
Portb.6 = 0
Portb.7 = 1

'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Main program ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Do

 Gosub White

Loop

End

'*************************** Subroutines *****************************
White:

 Do

  Select Case Pind

    'mostaghim
    Case &B0001000:

      Pwm1a = 1023
      Pwm1b = 1023

      Portb.0 = 1
      Portb.7 = 1


    'enheraf rast
    Case &B0010000:

      Pwm1a = 720


    'enheraf chap
    Case &B0000100:

      Pwm1b = 720


    'rast 90-120
    Case &B0000010:

      Gosub Rast_stop

      While Pind.3 = 0

        Portb.0 = 0

      Wend

      Portb.1 = 1

      Waitms 20

      Portb.1 = 0
      Portb.0 = 1


    'chap 90-120
    Case &B0100000:

      Gosub Chap_stop

      While Pind.3 = 0

        Portb.7 = 0

      Wend

      Portb.6 = 1

      Waitms 20

      Portb.6 = 0
      Portb.7 = 1


    'rast 60_1
    Case &B0001111:

      Gosub Rast_stop

      While Pind.5 = 0

        Portb.0 = 0

      Wend

      Portb.1 = 1

      Waitms 20

      Portb.0 = 1
      Portb.1 = 0


    'rast 60_2
    Case &B0000001:

      Gosub Rast_stop

      While Pind.5 = 0

        Portb.0 = 0

      Wend

      Portb.1 = 1

      Waitms 20

      Portb.0 = 1
      Portb.1 = 0


    'chap 60_1
    Case &B1111000:

      Gosub Chap_stop

      While Pind.1 = 0

        Portb.7 = 0

      Wend

      Portb.6 = 1

      Waitms 20

      Portb.6 = 0
      Portb.7 = 1


    'chap 60_2
    Case &B1000000:

      Gosub Chap_stop

      While Pind.1 = 0

        Portb.7 = 0

      Wend

      Portb.6 = 1

      Waitms 20

      Portb.6 = 0
      Portb.7 = 1


    'black detect_1
    Case &B1110111:

      Gosub Black


    'black detect_2
    Case &B1111111:

      Gosub Black


    'sayere halat
    Case Else

      Pwm1a = 1023
      Pwm1b = 1023

      Portb.0 = 1
      Portb.7 = 1


   End Select


 Loop

Return


'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Black:

 Do

  Select Case Pinb

    'mostaghim
    Case &B1110111:

      Pwm1a = 1023
      Pwm1b = 1023

      Portb.0 = 1
      Portb.7 = 1


    'enheraf rast
    Case &B1101111:

      Pwm1a = 720


    'enheraf chap
    Case &B1111011:

      Pwm1b = 720


    'rast 90-120
    Case &B1111101:

      Gosub Rast_stop

      While Pind.3 = 0

        Portb.0 = 0

      Wend

      Portb.1 = 1

      Waitms 20

      Portb.1 = 0
      Portb.0 = 1


    'chap 90-120
    Case &B1011111:

      Gosub Chap_stop

      While Pind.3 = 0

        Portb.7 = 0

      Wend

      Portb.6 = 1

      Waitms 20

      Portb.6 = 0
      Portb.7 = 1


    'rast 60_1
    Case &B1110000:

      Gosub Rast_stop

      While Pind.5 = 0

        Portb.0 = 0

      Wend

      Portb.1 = 1

      Waitms 20

      Portb.0 = 1
      Portb.1 = 0


    'rast 60_2
    Case &B1111110:

      Gosub Rast_stop

      While Pind.5 = 0

        Portb.0 = 0

      Wend

      Portb.1 = 1

      Waitms 20

      Portb.0 = 1
      Portb.1 = 0


    'chap 60_1
    Case &B0000111:

      Gosub Chap_stop

      While Pind.1 = 0

        Portb.7 = 0

      Wend

      Portb.6 = 1

      Waitms 20

      Portb.6 = 0
      Portb.7 = 1


    'chap 60_2
    Case &B0111111:

      Gosub Chap_stop

      While Pind.1 = 0

        Portb.7 = 0

      Wend

      Portb.6 = 1

      Waitms 20

      Portb.6 = 0
      Portb.7 = 1


    'white detect_1
    Case &B0001000:

      Gosub White


    'white detect_2
    Case &B0000000:

      Gosub White


    'sayere halat
    Case Else

      Pwm1a = 1023
      Pwm1b = 1023

      Portb.0 = 1
      Portb.7 = 1


  End Select


 Loop

Return


'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Rast_stop:

 Portb.0 = 0
 Portb.1 = 1

 Waitms 20

 Portb.0 = 0
 Portb.1 = 0

Return


'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Chap_stop:

 Portb.6 = 1
 Portb.7 = 0

 Waitms 20

 Portb.6 = 0
 Portb.7 = 0

Return